CREATE TABLE IF NOT EXISTS "ZkDevices" (
    "Serial" TEXT NOT NULL CONSTRAINT "PK_ZkDevices" PRIMARY KEY
);


CREATE TABLE IF NOT EXISTS "ZkPeople" (
    "Uid" TEXT NOT NULL CONSTRAINT "PK_ZkPeople" PRIMARY KEY,
    "Id" TEXT NULL,
    "Name" TEXT NULL
);


CREATE TABLE IF NOT EXISTS "ZkTimeZones" (
    "Uid" TEXT NOT NULL CONSTRAINT "PK_ZkTimeZones" PRIMARY KEY,
    "Id" INTEGER NOT NULL
);


CREATE TABLE IF NOT EXISTS "ZkBiodata" (
    "Pin" TEXT NOT NULL,
    "Index" INTEGER NOT NULL,
    "Type" INTEGER NOT NULL,
    "PersonUid" TEXT NOT NULL,
    "Version" TEXT NOT NULL,
    "Format" INTEGER NOT NULL,
    "BioData" TEXT NOT NULL,
    "Number" INTEGER NOT NULL,
    "Duress" TEXT NOT NULL,
    CONSTRAINT "PK_ZkBiodata" PRIMARY KEY ("Pin", "Index", "Type", "Version"),
    CONSTRAINT "FK_ZkBiodata_ZkPeople_PersonUid" FOREIGN KEY ("PersonUid") REFERENCES "ZkPeople" ("Uid") ON DELETE CASCADE
);


CREATE TABLE IF NOT EXISTS "ZkDeviceZkPerson" (
    "DevicesSerial" TEXT NOT NULL,
    "PersonsUid" TEXT NOT NULL,
    CONSTRAINT "PK_ZkDeviceZkPerson" PRIMARY KEY ("DevicesSerial", "PersonsUid"),
    CONSTRAINT "FK_ZkDeviceZkPerson_ZkDevices_DevicesSerial" FOREIGN KEY ("DevicesSerial") REFERENCES "ZkDevices" ("Serial") ON DELETE CASCADE,
    CONSTRAINT "FK_ZkDeviceZkPerson_ZkPeople_PersonsUid" FOREIGN KEY ("PersonsUid") REFERENCES "ZkPeople" ("Uid") ON DELETE CASCADE
);


CREATE INDEX IF NOT EXISTS "IX_ZkBiodata_PersonUid" ON "ZkBiodata" ("PersonUid");

CREATE INDEX IF NOT EXISTS "IX_ZkDeviceZkPerson_PersonsUid" ON "ZkDeviceZkPerson" ("PersonsUid");

CREATE INDEX IF NOT EXISTS "IX_ZkBiodata_Pin" ON "ZkBiodata" ("Pin");
